#include <iostream>
#include <algorithm>

using namespace std;

int main()
{
    int t;
    cin>>t;
    for(int iter=0; iter<t; iter++)
    {
        int n, m;
        cin>>n>>m;
        int a[n];
        int b[m];
        for(int i=0; i<n; i++)
            cin>>a[i];
        for(int i=0; i<m; i++)
            cin>>b[i];
        int mini=0;
        for(int i=1; i<n; i++)
        {
            if(a[i]<a[mini])
                mini=i;
        }
        for(int i=0; i<n; i++)
            a[i]-=a[mini];
        int d=a[0];
        for(int i=1; i<n; i++)
        {
            d=__gcd(d, a[i]);
        }
        bool u=true;
        for(int i=0; i<m && u; i++)
            if((b[i]-a[mini])%d == 0)
        {
            cout<<0;
            u=false;
        }
        if(u)
            cout<<1;
    }
}